module ds_intf_byte(
    clk             ,
    rst_n           ,
    rst_en          , 
    wr_en           ,
    wdata           ,
    rd_en           ,
    
    rdata           ,
    rdata_vld       ,
    rdy             ,
    //18b20 bitģ
    wr_en_bit       ,
    wdata_bit       ,
    rst_en_bit      ,
    rd_en_bit       ,
    //18b20 bitģ
    rdata_bit       ,
    rdata_vld_bit   ,
    rdy_bit          
    );

    //
    parameter      DATA_W =         8;

    parameter                     IDLE = 2'b00;
    parameter                    RST_S = 2'b01;
    parameter                    RD_S  = 2'b10;
    parameter                    WR_S  = 2'b11;       
            





    //źŶ
    input               clk    ;
    input               rst_n  ;
    input               rst_en ; 
    input               wr_en  ;
    input[DATA_W-1:0]   wdata  ;
    input               rd_en  ;

    input         rdata_bit    ;  
    input         rdata_vld_bit;  
    input         rdy_bit      ; 


    wire               rst_en ; 
    wire               wr_en  ;
    wire [DATA_W-1:0]   wdata  ;
    wire               rd_en  ;

    wire         rdata_bit    ;  
    wire         rdata_vld_bit;  
    wire         rdy_bit      ; 
    
    //źŶ
    
    output[DATA_W-1:0]   rdata ;
    output            rdata_vld;
    output               rdy   ;
                       
    output            wr_en_bit;
    output            wdata_bit;
    output           rst_en_bit;
    output            rd_en_bit;


    //źreg

    reg   [DATA_W-1:0]   rdata ;   
    reg               rdata_vld;
    reg                  rdy   ;

    reg               wr_en_bit;       
    reg               wdata_bit;       
    reg              rst_en_bit;      
    reg               rd_en_bit;       



    //мźŶ
    reg [1:0]                state_c;
    reg [1:0]                state_n;

    reg [DATA_W-1:0]      cnt  ;
    wire                add_cnt;
    wire                end_cnt;
    
    reg  [DATA_W-1:0]   wdata_r;

   

    wire              idl2rst_start;
    wire              idl2wr_start;
    wire              idl2rd_start;
    wire              rst2idl_start;
    wire              wr2idl_start;
    wire              rd2idl_start;



    //Ķʽ״̬

//һΣͬʱalwaysģ飬ʽ̬ĴǨƵ̬Ĵ(ģ
always@(posedge clk or negedge rst_n)begin
    if(!rst_n)begin
        state_c <= IDLE;
    end
    else begin
        state_c <= state_n;
    end
end

//ڶΣ߼alwaysģ飬״̬תж
always@(*)begin
    case(state_c)
        IDLE:begin
            if(idl2rst_start)begin
                state_n = RST_S;
            end
            else if(idl2wr_start)begin
                state_n =  WR_S;
            end
            else if(idl2rd_start)begin
                state_n =  RD_S;
            end
            else begin
                state_n = state_c;
            end
        end

        RST_S:begin
            if(rst2idl_start)begin
                state_n = IDLE;
            end
            else begin
                state_n = state_c;
            end
        end
        WR_S:begin
            if(wr2idl_start)begin
                state_n =IDLE;
            end
            else begin
                state_n = state_c;
            end
        end
        RD_S:begin
            if(rd2idl_start)begin
                state_n =IDLE;
            end
            else begin
                state_n = state_c;
            end
        end
        default:state_n = IDLE;
        
    endcase
end
//Σת
assign idl2rst_start  = state_c==IDLE  &&(rst_en==1&&rd_en==0&&wr_en==0);
assign idl2wr_start   = state_c==IDLE  &&(rst_en==0&&rd_en==0&&wr_en==1);
assign idl2rd_start   = state_c==IDLE  &&(rst_en==0&&rd_en==1&&wr_en==0);
assign rst2idl_start  = state_c==RST_S  && rdy_bit==1;
assign wr2idl_start   = state_c==WR_S   && end_cnt;
assign rd2idl_start   = state_c==RD_S   && end_cnt;

always @(posedge clk or negedge rst_n)begin
    if(!rst_n)begin
        cnt <= 0;
    end
    else if(add_cnt)begin
        if(end_cnt)
            cnt <= 0;
        else
            cnt <= cnt + 1;
    end
end

assign add_cnt = (state_c==WR_S&&rdy_bit)||(state_c==RD_S&&rdata_vld_bit);       
assign end_cnt = add_cnt && cnt== 8-1;   


//ĶΣͬʱalwaysģ飬ʽĴж
always  @(posedge clk or negedge rst_n)begin
    if(!rst_n)begin
         rst_en_bit <= 1'b0;      //ʼ
    end
    else if(state_c==RST_S&&rdy_bit)begin
        rst_en_bit <= 1'b1;
    end
    else begin
        rst_en_bit <= 1'b0;
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        wr_en_bit <= 1'b0;
    end
    else if(state_c==WR_S&&add_cnt)begin
        wr_en_bit <= 1'b1;
    end
    else begin
        wr_en_bit <= 1'b0;
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        wdata_r <= 0;
    end
    else if(idl2wr_start)begin
        wdata_r <= wdata;
    end
end


always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        wdata_bit <= 1'b0;
    end
    else if(state_c==WR_S&&add_cnt)begin
        wdata_bit <= wdata_r[cnt];
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        rd_en_bit <= 1'b0;
    end
    else if(state_c==RD_S&&rdy_bit)begin
        rd_en_bit <= 1'b1;
    end
    else begin
        rd_en_bit <= 1'b0;
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        rdata <= 0;
    end
    else if(state_c==RD_S&&add_cnt)begin
        rdata[cnt] <= rdata_bit;
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        rdata_vld <= 1'b0;
    end
    else begin
        rdata_vld <=rd2idl_start;
    end 
end

    //߼д
    always@(*)begin
        if(rst_en||rd_en||wr_en)
            rdy = 1'b0;
        else if(state_c!=IDLE)
            rdy = 1'b0;
        else
            rdy = 1'b1;
    end
        
 endmodule

