module tempe_dete(
    clk    ,
    rst_n  ,
    rx_uart,

    dq     ,

    tx_uart,
    seg_sel,
    segment,
//    led_err,
    beep       
    );

    //
    parameter      DATA_W =         8;
    parameter      CNT_BTL=      5208;

    //źŶ
    input               clk    ;
    input               rst_n  ;
    input               rx_uart;

    wire                rx_uart;

    inout                   dq ;

    wire                    dq ;

    //źŶ
    output                     tx_uart;  
    output[DATA_W-1:0]         seg_sel; 
    output[DATA_W-1:0]         segment; 
//    output                     led_err; 
    output                      beep  ;
    //źreg
    wire                     tx_uart; 
    wire [DATA_W-1:0]         seg_sel; 
    wire [DATA_W-1:0]         segment; 
//    wire                      led_err; 
    wire                      beep  ;

    //мźŶ

    wire                 dq_in;
    wire                dq_out;
    wire             dq_out_en;


    wire            uart_in_vld ;      
    wire[DATA_W-1:0]            uart_in;           
    wire            uart_out_vld;        
    wire[DATA_W-1:0]            uart_out;
    wire            uart_tx_rdy;
    wire [3:0]           a2h_dout;
    wire            a2h_dout_vld;
    wire            op_det_dout_vld;
    wire[DATA_W-1:0]            op_det_dout;
    wire[DATA_W-1:0]            ctrl_uart_out;
    wire            ctrl_uart_out_vld;
    wire            ctrl_h2a_en;
    wire            intf_rst_en;
    wire            intf_wr_en;
    wire[DATA_W-1:0]            intf_wdata;
    wire            intf_rd_en;
    wire[DATA_W-1:0]            intf_rdata;
    wire            intf_rdata_vld;
    wire            intf_rdy;
    wire[31:0]            temp_uns;
    wire            temp_valid_en;
    wire            bit_wr_en;
    wire            bit_wdata;
    wire            bit_rst_en;
    wire            bit_rd_en;
    wire            bit_rdata;
    wire            bit_rdata_vld;
    wire            bit_rdy;
    wire            wrreq;
    wire            empty;
    wire            temp_uns_sign_ascii;
    wire            ascii_dot;
    wire            ascii_enter;


    assign  dq    = (dq_out_en)? dq_out:1'bz;
    assign  dq_in = dq                     ;
    
    uart_rx #(.CNT_BTL(CNT_BTL)) u_uart_rx(
     .clk       (clk        ) ,
     .rst_n     (rst_n      ) ,
     .uart_rx   (rx_uart    ) ,

     .rx_vld    (uart_in_vld) , 
     .rx_data   (uart_in    )
    );

    uart_tx u_uart_tx(
     .clk      (clk         ) ,
     .rst_n    (rst_n       ) ,
     .tx_vld   (uart_out_vld) ,
     .tx_data  (uart_out    ) ,

     .uart_tx  (tx_uart     ) , 
     .tx_rdy   (uart_tx_rdy ) 
    );

    acsii2hex u_a2h(
     .clk       (clk         ) ,
     .rst_n     (rst_n       ) ,
     .din       (uart_in     ) ,
     .din_vld   (uart_in_vld ) ,
     
     .dout      (a2h_dout    ) ,
     .dout_vld  (a2h_dout_vld)     
    );

    opcode_dect u_op_det(
     .clk       (clk            ) ,
     .rst_n     (rst_n          ) ,
     .din       (a2h_dout       ) ,
     .din_vld   (a2h_dout_vld   ) ,

     .dout_vld  (op_det_dout_vld) ,
     .dout      (op_det_dout    )
    );

    control u_ctrl(
     .clk            (clk) ,
     .rst_n          (rst_n) ,
     .uart_in        (op_det_dout) ,//8λ
     .uart_in_vld    (op_det_dout_vld) ,

     .uart_out       (ctrl_uart_out) ,//8λ
     .uart_out_vld   (ctrl_uart_out_vld) ,
     .h2a_en         (ctrl_h2a_en) ,
     .intf_rst_en    (intf_rst_en) ,
     .intf_wr_en     (intf_wr_en) ,
     .intf_wdata     (intf_wdata) ,//8λ
     .intf_rd_en     (intf_rd_en) ,

     .intf_rdata     (intf_rdata) ,//8λ
     .intf_rdata_vld (intf_rdata_vld) ,
     .intf_rdy       (intf_rdy) ,

     .beep           (beep) ,
     .temp_uns       (temp_uns) ,//32λ
     .temp_valid_en  (temp_valid_en) 
    ); 

    hex2asscii u_h2a(
     .clk            (clk              ) ,
     .rst_n          (rst_n            ) ,
     .rdy            (uart_tx_rdy      ) ,
     .h2a_en         (ctrl_h2a_en      ) ,
     .din            (ctrl_uart_out    ) ,
     .din_vld        (ctrl_uart_out_vld) ,
     .dout           (uart_out         ) ,
     .dout_vld       (uart_out_vld     )  
    );

    ds_intf_byte u_ds_intf_byte(
     .clk            (clk           ) ,
     .rst_n          (rst_n         ) ,
     .rst_en         (intf_rst_en   ) , 
     .wr_en          (intf_wr_en    ) ,
     .wdata          (intf_wdata    ) ,//8λ
     .rd_en          (intf_rd_en    ) ,
     
     .rdata          (intf_rdata    ) ,//8λ
     .rdata_vld      (intf_rdata_vld) ,
     .rdy            (intf_rdy      ) ,
     //18b20 bitģ
     .wr_en_bit      (bit_wr_en     ) ,
     .wdata_bit      (bit_wdata     ) ,
     .rst_en_bit     (bit_rst_en    ) ,
     .rd_en_bit      (bit_rd_en     ) ,
     //18b20 bitģ
     .rdata_bit      (bit_rdata     ) ,
     .rdata_vld_bit  (bit_rdata_vld ) ,
     .rdy_bit        (bit_rdy       )  
    );

    ds_intf_bit u_ds_intf_bit(
     .clk            (clk          ) ,
     .rst_n          (rst_n        ) ,
     .rst_en         (bit_rst_en   ) ,
     .wr_en          (bit_wr_en    ) ,
     .wdata          (bit_wdata    ) ,
     .rd_en          (bit_rd_en    ) ,
     .dq_in          (dq_in        ) ,

     .rdata          (bit_rdata    ) ,
     .rdata_vld      (bit_rdata_vld) ,
     .dq_out         (dq_out       ) ,
     .dq_out_en      (dq_out_en    ) ,
     .rdy            (bit_rdy      ) 
    );

    
    seg_disp u_seg_disp(
     .clk             (clk          ) ,
     .rst_n           (rst_n        ) ,
     .disp_en         (temp_valid_en) ,
     .din             (temp_uns     ) ,
     .din_vld         (8'hff        ) ,

     .seg_sel         (seg_sel      ) ,
     .segment         (segment      ) 
    );


endmodule

