module uart_tx(
    clk    ,
    rst_n  ,
    tx_vld ,
    tx_data,

    uart_tx,
    tx_rdy 
    );

    //
    parameter      CNT_TX  =       10;
    parameter      CNT_BTL =     5208;
    parameter      BTL_W   =       20;
    parameter      TXCNT_W =        4;
    parameter      DATA_W  =        8;

    //źŶ
    input               clk    ;
    input               rst_n  ;
    input[DATA_W-1:0]   tx_data;    
    input               tx_vld ;
    
    wire [DATA_W-1:0]   tx_data; 
    wire                tx_vld ;
    //źŶ
    output              uart_tx;    
    output              tx_rdy ;

    //źreg
    reg                 uart_tx;
    reg                 tx_rdy ;
    reg                 flag   ;

    //мźŶ
    reg   [BTL_W -1:0]     cnt0;
    wire               add_cnt0;
    wire               end_cnt0;
    
    reg   [TXCNT_W-1:0]    cnt1;
    wire               add_cnt1;
    wire               end_cnt1; 

    reg [DATA_W-1:0]   tx_data_reg;

    wire[9:0]            data/*synthesis, probe_port,keep*/;

    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            flag <= 0;
        end
        else if(flag==0&&tx_vld)begin
            flag <= 1;
        end
        else if(end_cnt1)begin
            flag <= 0;
        end
    end

    always @(posedge clk or negedge rst_n)begin
        if(!rst_n)begin
            cnt0 <= 0;
        end
        else if(add_cnt0)begin
            if(end_cnt0)
                cnt0 <= 0;
            else
                cnt0 <= cnt0 + 1;
        end
    end

    assign add_cnt0 = flag;
    assign end_cnt0 = add_cnt0 && cnt0== CNT_BTL-1;

    always @(posedge clk or negedge rst_n)begin 
        if(!rst_n)begin
            cnt1 <= 0;
        end
        else if(add_cnt1)begin
            if(end_cnt1)
                cnt1 <= 0;
            else
                cnt1 <= cnt1 + 1;
        end
    end

    assign add_cnt1 = end_cnt0;
    assign end_cnt1 = add_cnt1 && cnt1== CNT_TX-1;

    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            uart_tx <= 1'b1;
        end
        else if(add_cnt0 && cnt0==1-1)begin
            uart_tx <= data[cnt1];
        end
    end
    assign    data = {1'b1,tx_data_reg,1'b0};

    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            tx_data_reg <= 8'd0;
        end
        else if(flag==1'b0&&tx_vld)begin
            tx_data_reg <= tx_data;
        end
    end
    
    //߼д
    always  @(*)begin
        if(tx_vld==1)begin
            tx_rdy = 0;
        end
        else if(flag==1) begin
            tx_rdy = 0;
        end
        else begin
            tx_rdy = 1;
        end    
    end

    endmodule

